package edu.cmu.qatar._15121.musicmanager;

public class MusicLibrary {

	/**
	 * 
	 * Add a song to the music library. Throws the SongAlreadyExistsException if the
	 * song to be added already exists in the library.
	 * 
	 * This method has no specific efficiency requirements, but you should avoid
	 * doing any linear searches through potentially large data structures. If you
	 * don't, your program may be too slow to pass the autograder.
	 * 
	 * @param artist The artist of the song
	 * @param title  The title of the song
	 * @param album  The album the song is a part of
	 * @param genre  The genre of the song
	 * @throws SongAlreadyExistsException when the song already exists in the
	 *                                    library.
	 */
	public void addSong(String artist, String title, String album, String genre) throws SongAlreadyExistsException {
		return;
	}

	/**
	 * Return all of the songs in the library
	 * 
	 * This must be O(N), where N is the number of songs in the library.
	 * 
	 * The order of the songs in the array does not matter.
	 * 
	 * @return Array of songs
	 */
	public Song[] getAllSongs() {
		return null;
	}

	/**
	 * Input the music database from the file specified by filename. If the file
	 * does not exist, then add nothing to the library.
	 * 
	 * If a song in the file cannot be added to the library (for example, it already
	 * exists) then just skip that song and process the rest of the file.
	 * 
	 * This method has no specific efficiency requirements, but in order to
	 * confidently pass the autograder you should be able to load 250,000 songs in
	 * 10 to 15 seconds.
	 * 
	 * @param filename The file to load the music from
	 */
	public void loadMusicDb(String filename) {
		return;
	}

	/**
	 * Return all of the artists in the library without duplicates
	 * 
	 * This must be O(M), where M is the number of artists.
	 * 
	 * @return Array of artist names
	 */
	public String[] getAllArtists() {
		return null;
	}

	/**
	 * Retrieve all of the songs by a given artist and return them
	 * 
	 * This must be O(M), where M is the number of songs by that artist.
	 * 
	 * @param artist The artist to search for
	 * @return An array of songs by the given artist. If the artist is not in the
	 *         MusicLibrary, return an empty array.
	 */
	public Song[] getSongsByArtist(String artist) {
		return null;
	}

	/**
	 * Retrieve all of the genres in the library without duplicates
	 * 
	 * This must be O(M), where M is the number of genres.
	 * 
	 * @return An array of strings, with each string being a genre
	 */
	public String[] getGenres() {
		return null;
	}

	/**
	 * Retrieve all of the songs with a given genre and return them
	 * 
	 * This must be O(M), where M is the number of songs within the specified genre.
	 * 
	 * @param genre The genre
	 * @return An array of songs with the given genre. If there are no songs with
	 *         that genre, return an empty array.
	 */
	public Song[] getSongsByGenre(String genre) {
		return null;
	}
}